Module | Needle::InterceptorChainBuilder
In: | lib/needle/interceptor-chain.rb

This module encapsulates the functionality for building interceptor chains.

### Methods

build

### Classes and Modules

Class Needle::InterceptorChainBuilder::InterceptedServiceProxy
Class Needle::InterceptorChainBuilder::InterceptorChainElement
Class Needle::InterceptorChainBuilder::ProxyObjectChainElement

### Constants

InvocationContext | = | Struct.new( :sym, :args, :block, :data ) |  | The context of a method invocation. This is used in an interceptor chain to encapsulate the elements of the current invocation. sym: the name of the method being invoked args: the argument list being passed to the method block: the reference to the block attached to the method invocation data: a hash that may be used by clients for storing arbitrary data in
           the context.

### Public Instance methods

build( point, service, interceptors )

This will apply the given interceptors to the given service by first ordering the interceptors based on their relative priorities, and then dynamically modifying the service‘s methods so that the chain of interceptors sits in front of each of them.

The modified service is returned.

[Validate]